#!/bin/sh

BACKLINK=$HTTP_REFERER
ARGC=1
. ./getargs.sh
. ./cgiComFuncs.sh

SECCOLOUR="#6699CC"
GRPCOLOUR="#6699CC"
BANCOLOUR="#6699CC"
case "$subset" in
	Sector) SECCOLOUR="#012fcb" ;;
	Group) GRPCOLOUR="#012fcb" ;;
	Band) BANCOLOUR="#012fcb" ;;
esac
NAME=`xlate $name`

if [ -z "$action" ]; then
	RESULT=""
else
	EXIST=`ascu_db_trans -db $subset.db -f "$NAME"`
	FUNC=`echo $action | sed "s/+$subset//"`
	case $FUNC in
		Add)
			if [ -z "$EXIST" ]; then
				ascu_db_trans -db $subset.db -w "$NAME	"
				RESULT="$subset $NAME added."
			else
				RESULT="$subset $NAME already exists."
			fi
			;;
		Delete)
			if [ -z "$EXIST" ]; then
				RESULT="$subset $NAME does not exist."
			else
				ascu_db_trans -db $subset.db -f "$NAME" -r
				RESULT="$subset $NAME deleted."
			fi
			;;
	esac
fi
SUBS=`ascu_db_trans -db $subset.db | cut -f 1 | sort -u | sed "s/ /+/g"`
./header.sh "$subset Configuration"
cat <<EOF
<table border=0 cellspacing=0 cellpadding=0 width=680 align=center summary="">
	<tr>
		<td valign=top>
			<table border=0 cellspacing=0 cellpadding=4 width=100 height=480 summary="Main menu">
				<tr>
					<td bgcolor=#6699CC nowrap><a href="/cgi-bin/index.cgi" class=menu>Main Page</a></td>
				</tr>
				<tr>
					<td bgcolor=#6699CC nowrap><a href="/cgi-bin/oldindex.cgi" class=menu>Old Main Page</a></td>
				</tr>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/status.cgi?subset=Device">&#149;&nbsp;Antenna Devices</A>
					</TD>
				</TR>
				<tr>
					<td bgcolor=#6699CC nowrap><a href="devconf.cgi" class=menu>&nbsp;&nbsp;&#150;&nbsp;Device Configuration</a></td>
				</tr>
				<tr>
					<td bgcolor=$SECCOLOUR nowrap><a href="addsub.cgi?subset=Sector" class=menu>&nbsp;&nbsp;&#150;&nbsp;Sector Configuration</a></td>
				</tr>
				<tr>
					<td bgcolor=$GRPCOLOUR nowrap><a href="addsub.cgi?subset=Group" class=menu>&nbsp;&nbsp;&#150;&nbsp;Group Configuration</a></td>
				</tr>
				<tr>
					<td bgcolor=$BANCOLOUR nowrap><a href="addsub.cgi?subset=Band" class=menu>&nbsp;&nbsp;&#150;&nbsp;Band Configuration</a></td>
				</tr>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/system.cgi">&#149;&nbsp;Controller</A>
					</TD>
				</TR>
                
				<TR>
					<TD bgColor=#6699CC height="100%">
						<PRE> </PRE>
					</TD>
				</TR>
			</table>
		</td>
		<td align=center width=12></td>
		<td valign=top align=left>
			<table border=0 width=530 cellspacing=0 cellpadding=0 summary="">
				<tr>
					<td><H3>$subset Configuration</H3></td>
				</tr>
			</table>
			<table border=2 cellspacing=0 cellpadding=4>
				<form  action="/cgi-bin/addsub.cgi" method=GET>
				<tr>
					<td><input type="text" name="name" size="25" value=""></td>
					<td><input type=submit name="action" value="Add $subset" class=button style="width: 100px"></td>
				</tr>
				<input type=hidden name=subset value=$subset>
				</form>
EOF

for UNQ in $SUBS ; do
	UNIT=`echo $UNQ | sed "s/+/ /g"`
	echo "<tr>"
	echo "<td>$UNIT</td>"
	echo '<form  action="/cgi-bin/subset.cgi" method=GET>'
	echo "<td><input type=submit name=action value=\"Edit $subset\" class=button style=\"width: 100px\"></td>"
	echo "<input type=hidden name=subset value=$subset>"
	echo "<input type=hidden name=name value=\"$UNIT\">"
	echo "</form>"
	echo '<form  action="/cgi-bin/addsub.cgi" method=GET>'
	echo "<td><input type=submit name=action value=\"Delete $subset\" class=button style=\"width: 100px\"></td>"
	echo "<input type=hidden name=subset value=$subset>"
	echo "<input type=hidden name=name value=\"$UNIT\">"
	echo "</form>"
	echo "</tr>"
done
cat <<EOF
			</table>
			<table border=0 cellspacing=0 cellpadding=4>
				<tr>
					<td>$RESULT</td>
				<tr>
			</table>
		</td>
	</tr>
</table>
</body>
</html>
EOF

