#!/bin/sh
. ./getargs.sh
. ./cgiComFuncs.sh
. ./cgiSysFuncs.sh
./header2.sh "Controller Configuration"

. ./login.sh
LogInLogic
GetOperatorName
if [ -z "$logOper" ] || [ "$logOper" = "10" ]; then
ConfigurePasswordButtons

SITE=`ascu_db_trans -db Site.db -f 1 | cut -f 2`

if [ -z "$action" ]; then
	RESULT=""
else
    . ./atc300ControllerConfigExe.cgi
fi

PTIME=`ascu_db_trans -db Site.db -f 5 | cut -f 2`
IPADDRINUSE=`ifconfig eth0 |grep "inet addr:" |cut -d ':' -f 2 |cut -d ' ' -f 1`
HOSTNMINUSE=`hostname`
if [ -f /HostName.txt ]; then
	HOSTNM=`cat /HostName.txt`
else
	HOSTNM=
fi
if [ -f /NetMask.txt ]; then
	NETMASK=`cat /NetMask.txt`
else
	NETMASK=
fi
if [ -f /Route.txt ]; then
	ROUTER=`cat /Route.txt`
else
	ROUTER=
fi
if [ -f /var/ascu/ExternalBusPwr.txt ]; then
	EXTERNALBUSPOWER=checked
fi

if [ -f /var/ascu/RelaysAreNC.txt ]; then
	RELAYSARENC=checked
fi

if [ -f /StaticIP.txt ]; then
	IPADDR=`cat /StaticIP.txt`
else
	DHCP=checked
	IPADDR=
fi
if [ -z "$SCAN" ]; then
	AUTO="selected"
	SINGLE=""
else
	case $SCAN in
		0)
			AUTO="selected"
			SINGLE=""
			;;
		1)
			AUTO=""
			SINGLE="selected"
			;;
	esac
fi
    
cat <<EOF
<script language="Javascript">

String.prototype.trim = function() {
   // Strip leading and trailing white-space
   return this.replace(/^\s*|\s*$/g, "");
}

function dhcponoff()
{
   // disable static ip field when dhcp is checked, and vice-versa
   var state = document.getElementById("dhcp").checked;

   document.getElementById("ipaddr").readOnly = state;
   document.getElementById("ipaddr").disabled = state;
}

function isAlphaNumeric(str)
{
   var re = /[^a-zA-Z0-9-]/g
   if (re.test(str)) return " expected characters a-z, A-Z, 0-9, or '-' only";
   return str;
}
//returns normalized IPv4 string, or leading space w/error message
function verifyIP (IPvalue)
{
   var ipPattern = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
   var ipArray = IPvalue.match(ipPattern);
   var numArray =new Array(4)
   var i

   if (ipArray==null)
   {
      return " expected X.X.X.X where X=0-255.";
   }
   for (i = 0; i < 4; i++)
   {
      numArray[i]=parseInt(ipArray[i+1],10)
      if (255<numArray[i])
      {
         return " expected X.X.X.X where X=0-255 .";
      }
   }
   IPvalue=numArray.join(".")
   if (IPvalue == "0.0.0.0" || IPvalue == "255.255.255.255")
      return " \'"+IPvalue+"\' is a special IP address and cannot be used here.";
   return IPvalue
}

function validForm(passform)
{
   var routr;
   var routrRetString;
   var ipstr;
   var ipretString;
   var hostname;
   var hostnameretString;
   var netmask;
   var maskretString;
   var dhcpstate = document.getElementById("dhcp").checked;

   hostname=passform.hostnm.value;
   hostname=hostname.trim();
   if ((dhcpstate) &&
       (hostname.length == 0))
   {
      alert("A hostname is required when DHCP is selected.");
      return false;
   }

   if (hostname.length >= 1)
   {
      hostnameretString=isAlphaNumeric(hostname);
      if (hostnameretString.substr(0,1)!=" ")
      {
         if ((hostnameretString.length > 1) &&
             (hostnameretString.length <= 32))
         {
            if ((hostnameretString.substr(0,1)!="-") &&
                (hostnameretString.lastIndexOf('-')<(hostnameretString.length-1)))
            {
               passform.hostnm.value=hostnameretString;
            }
            else
            {
               alert("Hostname cannot begin or end with '-'");
               return false;
            }
         }
         else
         {
            alert("Hostname must be 2 to 32 characters in length");
            return false;
         }
      }
      else
      {
         alert("You must supply a valid Hostname:"+hostnameretString);
         return false;
      }
   }

   ipstr=passform.ipaddr.value
   ipstr=ipstr.trim()
   if ((!dhcpstate) &&
       (ipstr.length == 0))
   {
      alert("A Static IP address is required when DHCP is unselected.");
      return false;
   }

   if (ipstr.length > 0)
   {
      ipretString=verifyIP(ipstr)
      if (ipretString.substr(0,1)!=" ")
         passform.ipaddr.value=ipretString
      else
      {
         alert("You must supply a valid IP Address for Static IP:"+ipretString)
         return false
      }
   }

   routr=passform.router.value
   routr=routr.trim()
   if (routr.length > 0)
   {
      routrRetString=verifyIP(routr)
      if (routrRetString.substr(0,1)!=" ")
         passform.router.value=routrRetString
      else
      {
         alert("You must supply a valid IP Address for Default Router:"+routrRetString)
         return false
      }
   }

   netmask=passform.netmask.value
   netmask=netmask.trim()
   if ((!dhcpstate) &&
       (netmask.length == 0))
   {
      alert("A Network Mask is required when DHCP is unselected.");
      return false;
   }

   if (netmask.length > 0)
   {
      maskretString=verifyIP(netmask)
      if (maskretString.substr(0,1)!=" ")
         passform.netmask.value=maskretString
      else
      {
         alert("You must supply a valid IP Address for Network Mask:"+maskretString)
         return false
      }
   }

EOF

if [ "$REMOTE_ADDR" != "10.254.254.254" ]; then
cat <<EOF
    return confirm("You are using this interface, make sure the parameters are correct. Proceed?");
EOF

else

cat <<EOF    
    return true;
EOF
fi

cat <<EOF
}

function validForm2(form)
{
   operator=form.operator.value;

   if (operator.length == 0 || operator == "10")
   {
        return (confirm("Are you sure you want to reboot?"));
   }
   else
   {
        alert("Feature is unavailable for this operator.");
        return false;
   }
}

function validSiteForm(form)
{
    if (form.site.value.length > 32)
    {
        alert("Site name too long.");
        return false;
    }
    return true;
}

</script>

EOF
if [ -n "$logOper" ]; then
cat <<EOF
<META HTTP-EQUIV=REFRESH CONTENT="190; URL=/cgi-bin/index.cgi">
EOF
fi
cat <<EOF

<table width="100%"  border="0" align="center" cellpadding="0" cellspacing="0" id="content" >
<tr><td>&nbsp;</td></tr>
  <tr><td>&nbsp;</td></tr>
  <tr><td>&nbsp;</td></tr>
  <tr id="title">
    <th colspan=3>
<label><span class="style1">Controller Configuration</span></label>
        &nbsp;
    </th>
    
<! START Password code>
    <tr>
    <td colspan="3"><div class="form_2">
        <fieldset>
        <legend>Password Protection: </legend>
        <form action="/cgi-bin/PasswordChange.cgi" name="siteform" method=GET>
        <table width="99%"  class="form_2" border="0" cellspacing="0" cellpadding="0">
          <tr>
            <td width="20%"><div align="right">
              <input type="submit" name="action" value="Disable Site Sharing"
              	 $DISABLE_PASSWORD_BUTTON>
            </div></td>
            <td width="20%"><div align="left">
              <input type="submit" name="action" value="Enable Site Sharing" 
              	$ENABLE_PASSWORD_BUTTON>
            </div></td>
          </tr>
        </table>
        </form>
EOF
if [ "$logOper" = "10" ]; then
cat <<EOF
        <form action="/cgi-bin/atc300OpnameConfig.cgi" name="operform" method=GET>
        <table width="99%"  class="form_2" border="0" cellspacing="0" cellpadding="0">
          <tr>
            <td width="20%"><div align="center">
              <input type="submit" name="action" value="Manage Operators">
          </tr>
        </table>
        </form>
        <form action="/cgi-bin/atc300DeviceAssign.cgi" name="assignform" method=GET>
        <table width="99%"  class="form_2" border="0" cellspacing="0" cellpadding="0">
          <tr>
            <td width="20%"><div align="center">
              <input type="submit" name="action" value="Assign Operators to Devices">
            </div></td>
          </tr>
        </table>
        </form>
EOF
fi
cat <<EOF
<! END password code> 
    <tr>
    <td colspan="3"><div class="form_2">
        <fieldset>
        <legend>Site Configuration: </legend>
        <form action="/cgi-bin/atc300ControllerConfig.cgi" name="siteform" method=GET onSubmit="return validSiteForm(this)">
        <table width="99%"  class="form_2" border="0" cellspacing="0" cellpadding="0">
          <tr>
            <td width="30%"><div align="right"> Site Name <br>
            </div></td>
            <td width="30%"><input name="site" size="32" type="text" value="$SITE"></td>
            <td width="20%"><div align="center">
              <input type="submit" name="action" value="Change Name">
            </div></td>
            <td width="20%"><div align="right">
              &nbsp;
            </div></td>
          </tr>
          <tr><td>&nbsp;</td></tr>
          <tr>
            <td><div align="right">
                <input type="checkbox" name="externalBusPower" $EXTERNALBUSPOWER>
            </div></td>
            <td width="30%"><div align="left"> Bus is externally powered <br>
            </div></td>
            <td width="20%"><div align="center">
              <input type="submit" name="action" value="Save Bus Config">
            </div></td>
          </tr>
          <tr>
            <td><div align="right">
                <input type="checkbox" name="relaysAreNC" $RELAYSARENC>
            </div></td>
            <td width="30%"><div align="left"> Configure alarm relays as Normally Closed <br>
            </div></td>
            <td width="20%"><div align="center">
              <input type="submit" name="action" value="Save Relay Config">
            </div></td>
          </tr>
        </table>
EOF
if [ -f /tmp/modem_voltages.txt ]; then
cat <<EOF
        <table width="50%"  class="form_2" border="0" cellspacing="0" cellpadding="0">
          <tr><td>&nbsp;</td></tr>
          <tr>
            <td><div align="center">
              <input type="submit" name="action" value="Clear Locked Data Ports">
            </div></td>
          </tr>
        </table>
EOF
fi
cat <<EOF
        </form>
        </fieldset>
    </div></td>
    </tr>
EOF

cat <<EOF
  <tr>
    <td colspan="3"><div class="form_2">
        <fieldset>
        <legend>Current IP Details:</legend>
        <form>
        <table width="99%"  class="form_2" border="0" cellspacing="0" cellpadding="0">
           <tr>
            <td align=right width="30%">IP&nbsp;Address:</td>
            <td width="30%"><input type="text" name="ipaddrinuse" size="16" value="$IPADDRINUSE" 
                readonly="readonly" class="ro"></td>
            <td width="20%"><div align="right">&nbsp;</div></td>
            <td width="20%"><div align="right">&nbsp;</div></td>
          </tr>
          <tr>
            <td align=right width="30%">Hostname:</td>
            <td width="30%"><input type="text" name="hostnminuse" size="20" value="$HOSTNMINUSE" 
                readonly="readonly" class="ro"></td>
            <td width="20%"><div align="right">&nbsp;</div></td>
            <td width="20%"><div align="right">&nbsp;</div></td>
          </tr>
        </table>
        </form>
        </fieldset>
    </div></td>
  </tr>
EOF
cat <<EOF
  <tr>
    <td colspan="3"><div class="form_2">
        <fieldset>
        <legend>IP Configuration:</legend>
        <form action="/cgi-bin/atc300ControllerConfig.cgi" method=GET onSubmit="return validForm(this)">
        <table width="99%"  class="form_2" border="0" cellspacing="0" cellpadding="0">
          <tr>
            <td align=right> Use&nbsp;DHCP:</td>
            <td><div align="left"><input type="checkbox" name="dhcp" id="dhcp" $DHCP onclick="dhcponoff()">
            </div></td>
          </tr>
           <tr>
            <td align=right width="30%">Hostname:</td>
            <td width="30%"><input type="text" name="hostnm" size="20" value="$HOSTNM"></td>
            <td width="20%"><div align="right">&nbsp;</div></td>
            <td width="20%"><div align="right">&nbsp;</div></td>
          </tr>
           <tr>
            <td align=right width="30%" name="ipaddrlabel" >Static&nbsp;IP&nbsp;Address:</td>
EOF
            if [ -z $DHCP ]; then
cat <<EOF          
               <td width="30%"><input type="text" name="ipaddr" size="16" value="$IPADDR"></td>
EOF
            else
cat <<EOF
               <td width="30%"><input type="text" name="ipaddr" size="16" value="$IPADDR" readonly="readonly"></td>
EOF
            fi
cat <<EOF
            <td width="20%"><div align="right">&nbsp;</div></td>
            <td width="20%"><div align="right">&nbsp;</div></td>
          </tr>
          <tr>
            <td width="30%" align=right>Default&nbsp;Router: </td>
            <td width="30%" valign="top"><input type="text" name="router" size="16" value="$ROUTER"></td>
            <td width="20%" align="center" valign="middle"><div align="left"> </div></td>
          </tr>
          <tr>
            <td align=right>Network&nbsp;Mask:<br>
            </td>
            <td>
              <div align="left">
                <input type="text" name="netmask" size="16" value="$NETMASK">
                </div></td>
            <td><div align="center">
              <input type="submit" name="action" value="Set IP Details">
            </div></td>
          </tr>
          <tr>
            <td><div align="right"> &nbsp;</div></td>
            <td><div align="right"> &nbsp;</div></td>
        </form>
        <form  action="/cgi-bin/atc300Upload.cgi" method=GET onSubmit="return validForm2(this)">
            <td align="center">
                <input type=hidden name="operator" value="$logOper">
                <input type="submit" name="action" value="Reboot">
              </td>
        </form>

            
          </tr>
        </table>
        </fieldset>
    </div></td>
  </tr>
EOF
cat <<EOF
  <tr>
    <td colspan="3"><div class="form_2">
        <fieldset>
        <legend>Date &amp; Time:</legend>
        <form action="/cgi-bin/atc300ControllerConfig.cgi" method=GET>
        <table width="99%"  class="form_2" border="0" cellspacing="0" cellpadding="0">
          <tr>          
EOF
 datetable -N $TARGET
cat <<EOF          
            <td width="27%" align="center" valign="top">
                <input type="submit" name="action" value="Set Date and Time">
              </td>
            <td width="14%"><div align="right">&nbsp;</div></td>
          </tr>
        </table>
        </form>
        </fieldset>
    </div></td>
    </tr>




</table>
EOF

if [ -z "$logOper" ]; then
    cat menubar.html
else 
  if [ "$logOper" = "10" ]; then
    cat menubar_admin.html
  else
    cat menubar_oper.html
  fi
fi
cat << EOF
    <div class="box">
      <table cellspacing="0" width="100%">
        <tbody>
          <tr>
            <td><label>Command Response: </label></td>
          </tr>
          <tr>
            <table>
            <tr>
            <td>
            <IFRAME WIDTH=100% HEIGHT=75px ALIGN="top" NAME=workerhog SRC>
            </IFRAME>
            </td>
            </tr>
            </table>
            </div>
          </tr>
        </tbody>
      </table>
      <table width="100%">
          <tr> <td>&nbsp;</td></tr>
          <tr>
            <td align=center>
                <input name="btnClose" type="button" id="btnClose" value="Close" onclick="parent.location='/cgi-bin/index.cgi'">
            </td>
          </tr>
      </table>
EOF


if [ -z "$action" ]; then
  echo >>/dev/null
else
cat << EOF
<script language=Javascript>
    workerhog.document.open();
    workerhog.document.write("$RESULT");
    workerhog.document.close();

</script>
EOF
fi

cat <<EOF
</body>
</html>
EOF
else
echo Feature is unavailable for this operator.
cat <<EOF
          <tr> <td>&nbsp;</td></tr>
          <tr>
            <td align=center>
                <input name="btnClose" type="button" id="btnClose" value="Close" onclick="parent.location='/cgi-bin/index.cgi'">
            </td>
          </tr>
EOF
fi

