#!/bin/sh

ARGC=1
. ./getargs.sh
. ./cgiComFuncs.sh
. ./cgiDevFuncs.sh

cat <<EOF
Content-type: text/html
Expires: Wed, 21 Aug 1968 00:01:00 GMT

<html>
<head>
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<title>Upgrade Progress</title>
<link rel=stylesheet href="/ascu.css" type="text/css">
</head>
<body>
<h3>Upgrade Progress</h3>
Waiting for command to begin...<br>
<script type="text/javascript">
    opener.document.getElementById("menubar").disabled = true;
</script>
EOF
	if [ "$action" = "Upload+File+to+Device" ]; then
		FAIL="Firmware installation was unsuccessful"
		if [ -z "$upgrade1" ]; then
			echo "No devices were selected <br>"
		else
			if [ -z "$type" ]; then
				echo "A file type must be specified <br>"
			else
				if [ -z "$url" ]; then
					echo "A valid filename must be provided <br>"
				else

					FLAGFILE=/tmp/fmwupg
					if [ -e "$FLAGFILE" ]; then
						exit
					fi
					trap 'rm $FLAGFILE' EXIT
					echo "$upgrade1" > "$FLAGFILE"

					file=`basename $url`
					echo "Selected file is $file <br>"
				fi
			fi
		fi

		if [ -n "$file" ]; then
#
# Loop through devices -- send one at a time so we can get feedback on status
#
			export TRIALLOOP="$upgrade1 $upgrade2 $upgrade3 $upgrade4 $upgrade5 $upgrade6 $upgrade7 $upgrade8 $upgrade9 $upgrade10 $upgrade11 $upgrade12 $upgrade13 $upgrade14 $upgrade15 $upgrade16 $upgrade17 $upgrade18 $upgrade19 $upgrade20 $upgrade21 $upgrade22 $upgrade23 $upgrade24 $upgrade25 $upgrade26 $upgrade27 $upgrade28 $upgrade29 $upgrade30 $upgrade31 $upgrade32 $upgrade33 $upgrade34 $upgrade35 $upgrade36 $upgrade37 $upgrade38 $upgrade39 $upgrade40 $upgrade41 $upgrade42 $upgrade43 $upgrade44 $upgrade45 $upgrade46 $upgrade47 $upgrade48 $upgrade49 $upgrade50 $upgrade51 $upgrade52 $upgrade53 $upgrade54 $upgrade55 $upgrade56 $upgrade57 $upgrade58 $upgrade59 $upgrade60 $upgrade61 $upgrade62 $upgrade63 $upgrade64"

			for ADDR in $TRIALLOOP ; do
				export QUERY_STRING="name=All&subset=Device&file=$file&command=50&action=$action&device=$ADDR&type=FMW"
				echo "$ADDR" > "$FLAGFILE"
				cat <<-EOF
				<H3>Upload File to Device</H3><br>
				Waiting on download...<br>
				Download can take several minutes.<br>
				<br>
				EOF
				/usr/bin/aisg_command -h -l
				cat <<-EOF
				<br>Done.<br>
				Note:  You may see 'Disconnected' as the result.<br>  This is normal.<br>&nbsp;<br>
				EOF
# refresh the screen to update the firmware version
sleep 20
cat <<EOF
<script type="text/javascript">
    opener.location.reload(true);
</script>
EOF
			done
		else
			echo $RESULT
			echo $FAIL
		fi
	fi

cat <<EOF
Please wait...<br>
EOF
sleep 2
cat<<EOF
<script type="text/javascript">
    opener.document.getElementById("menubar").disabled = false;
    opener.menus[0].disabled = true;
    opener.menus[1].disabled = true;
    opener.menus[2].disabled = true;
    opener.menus[3].disabled = true;
    opener.location.reload(true);
</script>
<input type=button value="Close Window" onClick="window.close(this)" class=button style="width: 110px"><br>
</body>
</html>
    
