#!/bin/sh

ARGC=1
. ./getargs.sh

cat <<EOF
Content-type: text/html
Expires: Wed, 21 Aug 1968 00:01:00 GMT

<html>
<head>
<title>Device Scan Progress</title>
<link rel=stylesheet href="/ascu.css" type="text/css">
</head>
<body>
<h3>About the Device Search</h3>
The device search uses an AISG Device Scan procedure to look for all attached
stations on the AISG bus.  This procedure is exhaustive, and it can take
several minutes to complete.  To cancel it, click <A HREF="cancelscan.cgi">here</A>. (Be patient, cancellation takes a few seconds)<br>
<h3>Device Search Progress</h3>
Waiting for device search command to begin...<br>
EOF
COUNT=0
while [ $COUNT -lt 10 ]; do
    if [ -f /tmp/devscanstarted.txt ]; then
		COUNT=10
	else
		sleep 1
	fi
done
FOUND=0
echo -n Found 0 devices so far...
while [ -f /tmp/devscanstarted.txt ]; do
    OLDFOUND=$FOUND
    FOUND=0
    DIFF=0
    if [ -f /tmp/devscanprog.txt ]; then
      FOUND=`cat /tmp/devscanprog.txt | wc | cut -b 1-9`
    fi
    if [ "$FOUND" -gt "$OLDFOUND" ]; then
      echo '<br>'
      let "DIFF=$FOUND-$OLDFOUND"
      tail -n $DIFF /tmp/devscanprog.txt
      echo '<br>'
      if [ "$FOUND" -gt "1" ]; then
          echo -n Found $FOUND devices so far...
      else
          echo -n Found $FOUND device so far...
      fi
            
    else
      echo -n .
    fi    
	sleep 1
done
echo '<br>'

# Finish
      if [ -f /tmp/devscanprog.txt ]; then
        FOUND=`cat /tmp/devscanprog.txt | wc | cut -b 1-9`
        if [ "$FOUND" -ne "1" ]; then
            echo -n Found $FOUND devices. '<br>'
        else
            echo -n Found $FOUND device. '<br>'
        fi
      else
        FOUND=0
        echo Found no 'devices.' '<br>'
      fi
		cat <<-EOF
        Scan is complete.<br>
		EOF

cat <<EOF
<input type=button value="Close Window" onClick="window.close(this)" class=button style="width: 110px"><br>
</body>
</html>
