#!/bin/sh

BACKLINK=$HTTP_REFERER
ARGC=1
. ../getargs.sh
. ../cgiComFuncs.sh
. ../cgiSysFuncs.sh

VFORM='function validateForm(form) { // validate form data
  if (!(boundsvalidation(form.cycles.value,100,1)))
  {
    alert("Cycles cannot be less than zero")
    form.cycles.focus()
    return false;
  }
  if (!(boundsvalidation(form.interval.value,86400,5)))
  {
    alert("Interval must be between 5 and 86400")
    form.interval.focus()
    return false;
  }
  if (!(floatvalidation(form.tdelta.value,21,0.1)))
  {
    alert("Delta must be at least 0.1")
    form.tdelta.focus()
    return false;
  }
  return true;
}'

export VFORM
../header.sh "Device Exercise"

DEVICES=`ascu_db_trans -db Device.db | cut -f 1`
cat <<EOF
<table border=0 cellspacing=0 cellpadding=0 width=680 align=center summary="">
	<tr>
		<td valign=top>
			<table border=0 cellspacing=0 cellpadding=4 width=100 height=480 summary="Main menu">
				<tr>
					<td bgcolor=#6699CC nowrap><a href="/cgi-bin/index.cgi" class=menu>Main Page</a></td>
				</tr>
				<tr>
					<td bgcolor=#6699CC nowrap><a href="/cgi-bin/oldindex.cgi" class=menu>Old Main Page</a></td>
				</tr>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/status.cgi?subset=Device">&#149;&nbsp;Site Status</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/site.cgi">&#149;&nbsp;Site Configuration</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/system.cgi">&#149;&nbsp;$UNIT Configuration</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/system.cgi">&nbsp;&nbsp;&#150;&nbsp;Basic Configuration</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/service.cgi">&nbsp;&nbsp;&#150;&nbsp;Service Menu</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/secure/admin.cgi">&nbsp;&nbsp;&#150;&nbsp;Admin Menu</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#012fcb noWrap>
						<A class=menu href="/cgi-bin/secure/cron.cgi">&nbsp;&nbsp;&#151;&nbsp;Device Exercise</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/fm.cgi?cat=/var/log/exedev">&nbsp;&nbsp;&#151;&nbsp;Display Log</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC height="100%">
						<PRE> </PRE>
					</TD>
				</TR>
			</table>
		</td>
		<td align=center width=12></td>
		<td valign=top align=left>
			<table border=0 width=530 cellspacing=0 cellpadding=4>
				<tr>
					<td><H3>Device Exercise</H3></td>
				</tr>
			</table>
			<hr>
EOF

RESULT=""

case $action in
	Add+Event)
		TARGET=`xlate $target`
		SUBSET=`echo $TARGET | cut -d ':' -f 1`
		NAME=`echo $TARGET | cut -d ':' -f 2`
		HOUR=`echo $hour | sed "s/-1/*/"`
		DAY=`echo $day | sed "s/-1/*/"`
		MONTH=`echo $month | sed "s/-1/*/"`
		WEEKDAY=`echo $weekday | sed "s/-1/*/"`
		if [ -f /etc/crontab ]; then
			md5sum /etc/crontab >/tmp/md5sum.$$
			cp /etc/crontab /tmp/crontab.$$
		fi
		echo "$minute $HOUR $DAY $MONTH $WEEKDAY /usr/bin/exedev -c $cycles -i $interval -t $tdelta -s $SUBSET -d $NAME >>/var/log/exedev" >>/tmp/crontab.$$
		sort -u -n /tmp/crontab.$$ >/tmp/crontab_new.$$
		crontab /tmp/crontab_new.$$
		qt rm /tmp/crontab.$$
		qt rm /tmp/crontab_new.$$
		RESULT="Event added"
		if [ -f /tmp/md5sum.$$ ]; then
			md5sum -s -c /tmp/md5sum.$$
			if [ $? = 0 ]; then
				RESULT="Duplicate event, not added"
			fi
			rm /tmp/md5sum.$$
		fi
		;;
	Delete)
		if [ -f /etc/crontab ]; then
			if [ -n "$md5sum" ]; then
				xlate $md5sum >/tmp/md5sum.$$
				md5sum -s -c /tmp/md5sum.$$
				if [ $? = 1 ]; then
					RESULT="Event table has changed - Event not deleted"
				fi
				rm /tmp/md5sum.$$
			fi	
			if [ -z "$RESULT" ]; then
				sed "$record"d /etc/crontab >/tmp/crontab.$$
				crontab /tmp/crontab.$$
				rm /tmp/crontab.$$
				RESULT="Event Deleted"
			fi
		else
			RESULT="Event table has changed - Event not deleted"
		fi
		;;
	esac

if [ -f /var/ascu/Sector.db ]; then
	cut -f 1 /var/ascu/Sector.db | sort -u >/tmp/Sector.$$
fi
if [ -f /var/ascu/Group.db ]; then
	cut -f 1 /var/ascu/Group.db | sort -u >/tmp/Group.$$
fi
if [ -f /var/ascu/Band.db ]; then
	cut -f 1 /var/ascu/Band.db | sort -u >/tmp/Band.$$
fi
if [ -f /etc/crontab ]; then
	export MD5=`md5sum /etc/crontab`
fi
if [ -n "$RESULT" ]; then
	export RESULT
fi
crontable -p $$
qt rm /tmp/Sector.$$
qt rm /tmp/Group.$$
qt rm /tmp/Band.$$
cat <<EOF
		</td>
	</tr>
</table>
</body>
</html>
EOF

