#!/bin/sh
#
# -f    do not fork.  Default is to nohub the daemon
# -Le   log to 'e'?
# -d    dump packets
# -c    override configuration file to indicated arg
# -a    log addresses
# -U    leave behind pid file
#
# If it's enabled only

if [ ! -f "/var/ascu/snmpd2.conf" ]; then
        sleep 6
        echo "Had to wait" 
fi

while [ ! -f "/var/ascu/Site.db" ] ; do
    echo "Had to wait on Site.db to load" 
    sleep 1
done

# look again...
if [ ! -f "/var/ascu/snmpd2.conf" ]; then
        echo "New config file"
        snmpcfg c /var/ascu/snmpd2.conf
fi

# Make sure snmpd is always enabled at startup
sed s/disable/enable/ /var/ascu/snmpd2.conf>/var/ascu/tempfile.conf
rm /var/ascu/snmpd2.conf
mv /var/ascu/tempfile.conf /var/ascu/snmpd2.conf

#
# if the token #@enable is present, start agent
#
while true; do

export TEMP0="`grep '#@enable' /var/ascu/snmpd2.conf | wc -l`"

if [ "$TEMP0" = "      1" ]; then
  if [ -e "/var/ascu/ADFlist.txt" ]; then
    rm /var/ascu/ADFlist.txt
  fi
  echo Starting snmpd
  for i in `ls /var/ascu/Antenna*.db` 
    do
      echo $i >> /var/ascu/ADFlist.txt
    done
  for i in `ls /var/ascu/ACRET1*.ar1t` 
    do
      echo $i >> /var/ascu/ADFlist.txt
    done
  snmpd -f -c/var/ascu/snmpd2.conf -a -U -p /var/run/snmpd.pid
  sleep 2
else
  echo Not starting snmpd
  sleep 5
fi

done
