#!/bin/sh

ARGC=1
. ./getargs.sh
. ./cgiComFuncs.sh
. ./cgiDevFuncs.sh

devaddr ()
{
# output an address for a device
	TMP=`ascu_db_trans -db Handle.db -f "	$1" | cut -f 1`
	if [ -z  "$TMP" ]; then
		echo "$1"
	else
		echo "$TMP"
	fi
}

BACKLINK="/cgi-bin/addsub.cgi?subset=$subset"
SECCOLOUR="#6699CC"
GRPCOLOUR="#6699CC"
BANCOLOUR="#6699CC"
NAME=`xlate $name`

if [ -z "$action" ]; then
	RESULT=""
else
	if [ -n "$device" ]; then
		UNIT=`devname $device`
		EXIST=`ascu_db_trans -db $subset.db -f "$NAME	$UNIT" -k 0`
		FUNC=`echo $action | sed "s/+$subset//"`
		case $FUNC in
			Add+To)
				if [ -z "$EXIST" ]; then
					ascu_db_trans -db $subset.db -w "$NAME	$UNIT"
					RESULT="$UNIT added to $subset $NAME."
				else
					RESULT="$UNIT already exists in $subset $NAME."
				fi
				;;
			Remove+From)
				if [ -z "$EXIST" ]; then
					RESULT="$UNIT does not exist in $subset $NAME."
				else
					ascu_db_trans -db $subset.db -f "$NAME	$UNIT" -k 0 -r
					RESULT="$UNIT removed from $subset $NAME."
				fi
				;;
		esac
	fi
fi

case $subset in
	Group)
		GRPCOLOUR="#012fcb"
#		ascu_db_trans -db $subset.db -f "$NAME" | cut -f 2 | sed "/^\$/d;s/^/\//;s/\$/\$\/d/" > /tmp/pattern.$$
		ascu_db_trans -db $subset.db -f "$NAME" | cut -f 2 > /tmp/pattern.$$
		;;
	Sector)
		SECCOLOUR="#012fcb"
#		ascu_db_trans -db $subset.db | cut -f 2 | sed "/^\$/d;s/^/\//;s/\$/\$\/d/" > /tmp/pattern.$$
		ascu_db_trans -db $subset.db | cut -f 2  > /tmp/pattern.$$
		;;
	Band)
		BANCOLOUR="#012fcb"
#		ascu_db_trans -db $subset.db | cut -f 2 | sed "/^\$/d;s/^/\//;s/\$/\$\/d/" > /tmp/pattern.$$
		ascu_db_trans -db $subset.db | cut -f 2 > /tmp/pattern.$$
		;;
esac

#if [ -z `head -n 1 /tmp/pattern.$$` ]; then
#	DEVICES=`ascu_db_trans -db Handle.db | cut -f 1`
#else
#	DEVICES=`ascu_db_trans -db Handle.db | sed -f /tmp/pattern.$$ | cut -f 1`
#fi

./header.sh "$subset Configuration"

cat <<EOF
<table border=0 cellspacing=0 cellpadding=0 width=680 align=center summary="">
	<tr>
		<td valign=top>
			<table border=0 cellspacing=0 cellpadding=4 width=100 height=480 summary="Main menu">
				<tr>
					<td bgcolor=#6699CC nowrap><a href="/cgi-bin/index.cgi" class=menu>Main Page</a></td>
				</tr>
				<tr>
					<td bgcolor=#6699CC nowrap><a href="/cgi-bin/oldindex.cgi" class=menu>Old Main Page</a></td>
				</tr>
				<tr>
					<td bgcolor=#6699CC nowrap><a href="$BACKLINK" class=menu>Back</a></td>
				</tr>
				<TR>
					<TD bgColor=#6699CC height="100%">
						<PRE> </PRE>
					</TD>
				</TR>
			</table>
		</td>
		<td align=center width=12></td>
		<td valign=top align=left>
			<table border=0 width=530 cellspacing=0 cellpadding=0 summary="">
				<tr>
					<td><H3>$subset $NAME Configuration</H3></td>
				</tr>
			</table>
			<table border=2 cellspacing=0 cellpadding=4>
				<form  action="/cgi-bin/subset.cgi" method=GET>
				<input type="hidden" name="subset" value="$subset">
				<input type="hidden" name="name" value="$NAME">
				<tr>
					<td><select name=device>
EOF
if [ -f `head -n 1 /tmp/pattern.$$` ]; then
#	DEVICES=`ascu_db_trans -db Handle.db | sed -f /tmp/pattern.$$ | cut -f 1`
    ascu_db_trans -db Handle.db -F '<option value=%d> %s </option>' -X /tmp/pattern.$$
else
#	DEVICES=`ascu_db_trans -db Handle.db | cut -f 1`
   ascu_db_trans -db Handle.db -F '<option value=%d> %s </option>'
fi

cat <<EOF
					</select>
					</td>
					<td><input type=submit name ="action" value="Add To $subset" class=button style="width: 100px"></td>
				</tr>
				</form>
EOF
	COUNT=`ascu_db_trans -db $subset.db -f "$NAME" | cut -f 2 | sed "/^$/d" | wc -l`
	if [ "$COUNT" -gt 0 ] ; then
		DC=0
		while [ "$DC" -lt "$COUNT" ]; do
			let DC=$DC+1
			USED=`ascu_db_trans -db $subset.db -f "$NAME" | cut -f 2 | sed "/^$/d" | sed -n "$DC"'p'`
			echo "<tr>"
			echo "<td>$USED</td>"
			echo '<form  action="/cgi-bin/subset.cgi" method=GET>'
			echo "<td><input type=submit name=action value=\"Remove From $subset\" class=button></td>"
			echo "<input type=hidden name=subset value=$subset>"
			echo "<input type=hidden name=name value=\"$NAME\">"
			echo "<input type=hidden name=device value=\"`devaddr "$USED"`\">"
			echo "</form>"
			echo "</tr>"
		done
	fi

cat <<EOF
			</table>
			<table border=0 cellspacing=0 cellpadding=4>
				<tr>
					<td>$RESULT</td>
				<tr>
			</table>
		</td>
	</tr>
</table>
</body>
</html>
EOF
rm /tmp/pattern.$$

