#!/bin/sh

ARGC=1
. ./getargs.sh
. ./cgiComFuncs.sh
. ./cgiDevFuncs.sh

if [ "$action" != "Command" ]; then
   export CMD_RESULT=`/usr/bin/aisg_command -l -b "<tr><td>" -e "</td></tr>" -s "</td><td>"`
fi

BACKLINK="/cgi-bin/status.cgi"

./header.sh "Device Support"


cat <<EOF
<table border=0 cellspacing=0 cellpadding=0 width=680 align=center summary="">
	<tr>
		<td valign=top>
			<table border=0 cellspacing=0 cellpadding=4 width=100 height=480 summary="Main menu">
				<tr>
					<td bgcolor=#6699CC nowrap><a href="/cgi-bin/index.cgi" class=menu>Main Page</a></td>
				</tr>
				<tr>
					<td bgcolor=#6699CC nowrap><a href="/cgi-bin/oldindex.cgi" class=menu>Old Main Page</a></td>
				</tr>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/status.cgi?subset=Device">&#149;&nbsp;Antenna Devices</A>
					</TD>
				</TR>                
				<tr>
					<td bgcolor=#6699CC nowrap><a href="$BACKLINK" class=menu>&nbsp;&nbsp;&#150;&nbsp;$subset View</a></td>
				</tr>
				<TR>
					<TD bgColor=#012fcb noWrap>
						<A class=menu href="/cgi-bin/support.cgi">&nbsp;&nbsp;&#151;&nbsp;Device Support</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/system.cgi">&#149;&nbsp;Controller</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC height="100%">
						<PRE> </PRE>
					</TD>
				</TR>
			</table>
		</td>
		<td align=center width=12></td>
		<td valign=top align=left>
EOF


if [ -z "$action" ]; then
	# Get input from the punter
#	devtable -s Device -n All
    
	devtable -s Device -n All -a Upgrade
else
	if [ "$action" = "Upload+File+to+Device" ]; then
		FAIL="Firmware installation was unsuccessful"
		if [ -z "$device" ]; then
			RESULT="No devices were selected"
		else
			if [ -z "$type" ]; then
				RESULT="A file type must be specified"
			else
				if [ -z "$url" ]; then
					RESULT="A valid URL for the file must be provided"
				else
					URL1=`echo $url | sed "s/%3A/:/g;s/%2F/\//g"`
					URL=`echo $URL1 | sed "s/ftp:\/\///"`
					file=`basename $URL`
					if [ -n "$username" ]; then
						USER="$username:$password@"
					else
						USER=""
					fi
					RESULT=`wget -O /tmp/$file -q ftp://$USER$URL 2>&1`
					if [ $? = 1 ]; then
						RESULT="Unable to access ftp://$URL"
					fi
				fi
			fi
		fi
		if [ -z "$RESULT" ]; then
			QUERY_STRING="name=All&subset=Device&file=$file&command=50&$QUERY_STRING"
			cat <<-EOF
				<table border=0 width=530 cellspacing=0 cellpadding=0 summary="">
					<tr>
						<td><H3>Upload File to Device</H3></td>
					</tr>
				</table>
				<table border=2 cellspacing=0 cellpadding=4>
				<tr>
					<td><H4>Device</H4></td><td><H4>Command</H4></td><td colspan=10><H4>Result</H4></td>
				</tr>
				`/usr/bin/aisg_command -l -b "<tr><td>" -e "</td></tr>" -s "</td><td>"`
				</table>
			EOF
		else
			echo "<pre>"
			echo $RESULT
			echo
			echo $FAIL
			echo "</pre>"
		fi
	fi
	if [ -n "$file" ]; then
		qt rm /tmp/$file
	fi
fi

cat <<EOF
        <HR>
		</td>
	</tr>
</table>
</body>
</html>
EOF
