#!/bin/sh

test=$1
dwell=$2
devs=$3
tmax=$4
tmin=$5

LIST=""
if [ "$test" = "1" ]; then
	LIST="0 7"
fi
if [ "$test" = "2" ]; then
	LIST="0 2.3 4.6 7 4.6 2.3"
fi
if [ "$test" = "3" ]; then
	LIST="2 4 6 8"
fi
if [ -z "$LIST" ]; then
	exit 0
fi
if [ -z "$dwell" ]; then
	dwell=120
fi
if [ "$dwell" -lt 20 ]; then
	dwell=20
fi
echo $dwell > /var/run/test.dwell
if [ -z "$tmax" ]; then
	tmax=42
fi
if [ -z "$tmin" ]; then
	tmin=35
fi
if [ "$tmin" -lt 32 ]; then
	tmin=32
fi
if [ "$tmax" -lt "$tmin" ]; then
	let tmax=$tmin+10
fi
if [ "$devs" = 0 ];then
	devs=`cut -f 1 /var/ascu/Device.db`
fi
rm /tmp/test.*
echo $$ >/var/run/test.pid

timestamp=`date | sed "s/UTC //"`
echo "$timestamp,Test Started,Dwell=$dwell,Tmax=$tmax,Tmin=$tmin" >> /var/log/test
echo "Address,Command,Product,Serial,HWVersion,SWVersion" >> /var/log/test
for name in $devs ; do
	export QUERY_STRING="name=$name&command=5"
	/usr/bin/aisg_command -s , >> /var/log/test
done
echo "Timestamp,Tilt,Temp,Address,Response" >> /var/log/test
while true ; do
	for tilt in $LIST ; do
		devs=`cat /var/run/test.name`
		if [ "$devs" = 0 ];then
			devs=`cut -f 1 /var/ascu/Device.db`
		fi
	   	for name in $devs ; do
   			NOW=`date +%s`
			tmax=`cat /var/run/test.tmax`
			tmin=`cat /var/run/test.tmin`
   			RUN=0
   			export QUERY_STRING="tilt=$tilt&name=$name&command=51"
	   		TEMP=`rettemp -d $name`
	   		if [ -f /tmp/test.$name ]; then
	   			RUN=1
	   		fi
	   		if [ "$TEMP" -gt $tmax ]; then
	   			RUN=1
	   			echo -n > /tmp/test.$name
	   		fi
	   		if [ $RUN = 1 ]; then
	   			if [ $TEMP -lt $tmin ]; then
	   				RUN=0
	   				rm /tmp/test.$name
	   			fi
	   		fi
	   		timestamp=`date | sed "s/UTC //"`
	   		echo -n $timestamp, >> /var/log/test
	   		echo -n $tilt, >> /var/log/test
	   		echo -n $TEMP, >> /var/log/test
	   		if [ $RUN = 0 ]; then
	   			# Set Tilt
	   			/usr/bin/aisg_command -s , >> /var/log/test
	   		else
	   			echo "$name,Waiting for temp < $tmin" >> /var/log/test
	   		fi
	   		export QUERY_STRING="action=Get+Queue+Depth"
	   		QD=1
	   		while [ $QD != 0 ]; do
	   			QD=`aisg_command | cut -f 4`
	   			sleep 1
	   		done
	   		TEMP=`rettemp -d $name`
	   		timestamp=`date | sed "s/UTC //"`
	   		echo -n $timestamp, >> /var/log/test
	   		echo -n $tilt, >> /var/log/test
	   		echo -n $TEMP, >> /var/log/test
	   		# Get tilt
	   		export QUERY_STRING="tilt=$tilt&name=$name&command=52"
	   		if [ $RUN = 0 ]; then
	   			/usr/bin/aisg_command -s , >> /var/log/test
	   		else
	   			echo "$name,Waiting for temp < $tmin" >> /var/log/test
	   		fi
			dwell=`cat /var/run/test.dwell`
	   		let LATENCY=`date +%s`-$NOW
	   		if [ $LATENCY -lt $dwell ]; then
	   			let ZZZ=$dwell-$LATENCY
	   			sleep $ZZZ
	   		fi
	   	done
	done
done
